/* 	Kurs programowania mikrokontrolerowe Megawin
		Projekt 05 - obsluga interfejsu I2C */

#include "mg32f10x.h"
#include "hardware.h"
#include "mcp9808.h"

volatile uint8_t pos = 0;

/* akumulator do usredniania probek */
volatile uint32_t volt_avg = 0;
	
/* podwojnie buforowana obsluga zawartosci wyswietlacza */
volatile uint16_t disp_num = 0;
volatile uint16_t disp_num_shadow = 0;

uint32_t cnt = 0;

int main(void)
{
	
	const uint8_t num_samples = 64;

	uint32_t adc_tmp = 0;
	uint32_t volt_avg = 0;

	initPeripherals();
	
	LED_onoff(1, LED_OFF);
	LED_onoff(2, LED_OFF);
	
  while (1)
  {
		
		cnt++;
		if(cnt > 99){
			
			cnt = 0;
			/* odczyt temperatury */
			disp_num = mcp9808_read_temp();
			
			/* sygnalizacja przekroczenia 30.00*C za pomocą czerwonej diody LED */
			if(disp_num > 3000)
				LED_onoff(2, LED_ON);
			else
				LED_onoff(2, LED_OFF);

		}		
		
		delay(1);

	}

}


#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t* file, uint32_t line)
{ 
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */

  /* Infinite loop */
  while (1)
  {
  }
}
#endif
