#include "hardware.h"

void initPeripherals(void){
	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_BMX1 |
													RCC_APB1Periph_GPIOA |
													RCC_APB1Periph_GPIOB |
													RCC_APB1Periph_GPIOC |
													RCC_APB1Periph_GPIOD, ENABLE);
	
  GPIO_Init(LED1_port, LED1_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(LED2_port, LED2_pin, GPIO_MODE_OUT | GPIO_OTYPE_PP | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_A_port, DISP_A_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_B_port, DISP_B_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_C_port, DISP_C_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_D_port, DISP_D_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_E_port, DISP_E_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_F_port, DISP_F_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_G_port, DISP_G_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_DP_port, DISP_DP_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	
	GPIO_Init(DISP_COM1_port, DISP_COM1_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM2_port, DISP_COM2_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM3_port, DISP_COM3_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);
	GPIO_Init(DISP_COM4_port, DISP_COM4_pin, GPIO_MODE_OUT |GPIO_OTYPE_PP |GPIO_PUPD_NOPULL |GPIO_SPEED_LOW);

	GPIO_Init(SW1_port, SW1_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);
	GPIO_Init(SW2_port, SW2_pin, GPIO_MODE_IN | GPIO_PUPD_NOPULL | GPIO_SPEED_LOW);

	GPIO_Init(POT_port, POT_pin, GPIO_MODE_ANA);

	/* I/O podlaczone do potencjometru jako wejscie analogowe */
	GPIO_Init(POT_port, POT_pin, GPIO_MODE_ANA);

	/* konfiguracja linii SDA i SCL jako AF nr 4, linie typu otwarty dren */
	GPIO_Init(GPIOB, GPIO_Pin_10, GPIO_MODE_AF |GPIO_OTYPE_OD | GPIO_PUPD_NOPULL |GPIO_SPEED_HIGH |GPIO_AF4);
	GPIO_Init(GPIOB, GPIO_Pin_11, GPIO_MODE_AF |GPIO_OTYPE_OD | GPIO_PUPD_NOPULL |GPIO_SPEED_HIGH |GPIO_AF4);
	

	/* domyslna konfiguracja SysTicka z czestotliwoscia 1 kHz @ SYSCLK = 72 MHz */
	SysTick_Config(72000000 / 1000);

	/* konfiguracja interfejsu I2C */
	I2C_config();

}

void LED_onoff(uint8_t led, LED_state_t state){
	
	if(led == 1){
		
			if(state == LED_ON)
					GPIO_ResetBits(LED1_port, LED1_pin);
			else
					GPIO_SetBits(LED1_port, LED1_pin);
		
	}else if(led == 2){

			if(state == LED_ON)
					GPIO_ResetBits(LED2_port, LED2_pin);
			else
					GPIO_SetBits(LED2_port, LED2_pin);
		
	}
}

void delay(uint32_t ms){
	
	for(uint32_t i = 0; i < 3600; i++){
			for(uint32_t j = 0; j < ms; j++) __NOP();
	}
					
}


void display_select_pos(uint8_t pos){
	
	/* obsluga pozycji dziesietnych wyswietlacza (wspolne anody) */
	
	switch(pos){
		
		case 0:
			GPIO_ResetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;
		
		case 1:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_ResetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;		
		
		case 2:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_ResetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
		
		case 3:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_ResetBits(DISP_COM4_port, DISP_COM4_pin);
			break;	
	
		default:
			GPIO_SetBits(DISP_COM1_port, DISP_COM1_pin);
			GPIO_SetBits(DISP_COM2_port, DISP_COM2_pin);
			GPIO_SetBits(DISP_COM3_port, DISP_COM3_pin);
			GPIO_SetBits(DISP_COM4_port, DISP_COM4_pin);
		
	}
}

void display_select_digit(uint8_t dig, uint8_t dp){
	
	/* obsluga segmentow wyswietlacza (katody) */
	
	switch(dig){
		
		case 0:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 1:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 2:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 3:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;	

		case 4:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 5:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
	
		case 6:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 7:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;

		case 8:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_SetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;
		
		case 9:
			GPIO_SetBits(DISP_A_port, DISP_A_pin);
			GPIO_SetBits(DISP_B_port, DISP_B_pin);
			GPIO_SetBits(DISP_C_port, DISP_C_pin);
			GPIO_SetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_SetBits(DISP_F_port, DISP_F_pin);
			GPIO_SetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
			break;		
		
		default:
			GPIO_ResetBits(DISP_A_port, DISP_A_pin);
			GPIO_ResetBits(DISP_B_port, DISP_B_pin);
			GPIO_ResetBits(DISP_C_port, DISP_C_pin);
			GPIO_ResetBits(DISP_D_port, DISP_D_pin);
			GPIO_ResetBits(DISP_E_port, DISP_E_pin);
			GPIO_ResetBits(DISP_F_port, DISP_F_pin);
			GPIO_ResetBits(DISP_G_port, DISP_G_pin);
			GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);

	}	
	
	/* obsluga punktu dziesietnego */
	if(dp){
		GPIO_SetBits(DISP_DP_port, DISP_DP_pin);
	}else{
		GPIO_ResetBits(DISP_DP_port, DISP_DP_pin);
	}
		
}

void ADC_config(void) {
	
	/* wlaczenie sygnalu taktowania ADC i niezbednych zegarow dodatkowych */
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_ADC | RCC_APB1Periph_BMX1| RCC_APB1Periph_AFIO, ENABLE);
	
	/* odblokowanie bloku kontrolnego funkcji analogowych w celu zapisu  */
	PWR_UnlockANA();
	
	/* zezwolenie na prace przetwornika ADC */
	ANCTL_SARADCCmd(ENABLE);
	
	/* przywrocenie stanu zablokowanego w celu ochrony waznych rejestrow*/
	PWR_LockANA();

	/* struktura inicjalizacyjna ADC */
	ADC_InitTypeDef	init;
	
	/* uzywamy pojedynczej konwersji, wiec nie potrzebujemy trybu ciaglego skanowania */
	init.ADC_ScanConvMode = DISABLE;
	init.ADC_ContinuousConvMode = DISABLE;
	
	/* nie uzywamy sprzetowego triggera (wyzwalanie programowe) */
	init.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;
	
	/* wyrownanie danych do prawej (zera po stronie MSB) */
	init.ADC_DataAlign = ADC_DataAlign_Right;
	
	/* jeden kanal do konwersji */
	init.ADC_NbrOfChannel = 1;
	
	/* inicjalizacja przetwornika */
	ADC_Init(&init);
	
	/* uzywamy tylko kanalu nr 14, wybieramy mozliwie dlugi czas probkowania */
	ADC_RegularChannelConfig(ADC_Channel_14, 1, ADC_SampleTime_239Cycles5);
	
	/* zezwolenie na wyzwalanie przetwornika */
	ADC_ExternalTrigConvCmd(ENABLE);

	/* wlaczenie bloku przetwornika */
	ADC_Cmd(ENABLE);
	
	/* zerowanie ustawien kalibracyjnych */
	ADC_ResetCalibration();
	
	/* oczekiwanie na gotowosc do rozpoczecia kalibracji */
	while(ADC_GetResetCalibrationStatus());

	/* rozpoczecie kalibracji */
	ADC_StartCalibration();
	
	/* oczekiwanie na zakonczenie kalibracji */
	while(ADC_GetCalibrationStatus());
	

}

void I2C_config(void)
{
	
	/* wlaczenie taktowania interfejsu I2C i odpowiedniego sygnalu szyny systemowej */
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_BMX2 | RCC_APB2Periph_I2C2, ENABLE);

  /*
    PB10 (I2C2_SCL)
    PB11 (I2C2_SDA)
  */

	/* wstepne zerowanie konfiguracji I2C */
	I2C_DeInit(I2C2);
	
	/* 	- tryb mastera
		- standardowa szybkosc transferu
		- zabezpieczenie szyny przed bledami ("zatrzasniecie" SDA lub SCL na stanie niskim)
		- zezwolenie na powtorzony start
	*/
	I2C_Init(I2C2, I2C_CON_SLAVE_DISABLE  | I2C_CON_SPEED_STANDARD | I2C_CON_MASTER_MODE | I2C_CON_BUS_CLEAR_FEATURE_CTRL | I2C_CON_RESTART_EN);
	
	/* ustawienie adresu slave'a */
	I2C_TargetAddressConfig(I2C2, 0x18);

	/* parametry timingow linii SDA i SCL */
	
	/* tHIGH = (280 + FS_SPKLEN + 7) / 72 MHz = 4 us */
	I2C2->SS_SCL_HCNT = 280;  
	
	/* tLOW = (339 + 1) / 72 MHz = 4,708 us */
	I2C2->SS_SCL_LCNT = 339;  
	
	/* tSP = 3 / 72 MHz = 41,67 ns */
	I2C2->FS_SPKLEN = 3;      
	
	/* tSU;DAT = 18 / 72 MHz = 250 ns */
	I2C2->SDA_SETUP = 18;     
	
	/* tHD;DAT = 22 / 72 MHz = 302,08 ns */
	I2C2->SDA_HOLD = 22;      

	/* I2C SCL Stuck at Low Timeout = 720000 / 72 MHz = 10 ms */
	I2C2->SCL_STUCK_AT_LOW_TIMEOUT = 720000;  
	
}
